/**
 * \file
 *
 * \brief Driver ISR.
 *
 (c) 2020 Microchip Technology Inc. and its subsidiaries.

    Subject to your compliance with these terms,you may use this software and
    any derivatives exclusively with Microchip products.It is your responsibility
    to comply with third party license terms applicable to your use of third party
    software (including open source software) that may accompany Microchip software.

    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY IMPLIED
    WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS FOR A
    PARTICULAR PURPOSE.

    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE,
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP HAS
    BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO THE
    FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL CLAIMS IN
    ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT OF FEES, IF ANY,
    THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS SOFTWARE.
 *
 */

/*
 * Code generated by START.
 *
 * This file will be overwritten when reconfiguring your START project.
 * Please copy examples or other code you want to keep to a separate file
 * to avoid losing it when reconfiguring.
 */

#include <driver_init.h>
#include <compiler.h>
extern 	uint32_t  result;
extern uint32_t P_active, Irms, Vrms, P_apparent, P_reactive;

extern int16_t i_inst, v_inst, power_factor;
extern uint16_t N; 
//ISR(AC0_AC_vect)
//{
	///* Insert your AC interrupt handling code here */
//
	///* The interrupt flag has to be cleared manually */
	//AC0.STATUS = AC_CMP_bm;
//}
volatile uint8_t flag_8bit = 0;
//volatile uint16_t result = 0;
uint32_t spi_output= 0x12345678;;
uint8_t reg_addr;
uint8_t temp;
extern bool pos_angle, pos_pf;
ISR(SPI0_INT_vect)
{
		//VPORTB.OUT |= (1 << 7);
		
		
		//if((SPI0.INTFLAGS & SPI_DREIE_bm))
		//{
		//VPORTB.OUT |= (1 << 7);
		//
		switch(flag_8bit){
			case 0 :
			//result= ADC_0_get_conversion_result();
			//result = ADC0.RESULT;
			temp = SPI0.DATA;
			reg_addr = SPI0.DATA;
			SPI0.DATA = spi_output;
			spi_output = spi_output>>8;
			flag_8bit = 1;
			break;
			//while(!(SPI0.INTFLAGS & SPI_DREIE_bm));
			case 1:
			//reg_addr = SPI0.DATA;
			SPI0.DATA = spi_output;
			spi_output = spi_output >>8;
			flag_8bit = 2;
			break;

			case 2 :
			//result= ADC_0_get_conversion_result();
			//result = ADC0.RESULT;
			temp = SPI0.DATA;
			SPI0.DATA = spi_output;
			spi_output = spi_output >>8;
			flag_8bit = 3;
			break;
			//while(!(SPI0.INTFLAGS & SPI_DREIE_bm));
			case 3:
			temp = SPI0.DATA;
			SPI0.DATA = spi_output;
			spi_output = spi_output >>8;
			flag_8bit = 4;
			break;

			case 4:
			//spi_output = spi_output >>8;
			//spi_output =  i_inst<<16 | v_inst;
			switch(reg_addr>>1)//shift spi read/write bit out
			{
				case 0x20:
				spi_output = (uint32_t)Irms<<16 |(uint16_t)Vrms;
				break;
				
				case 0x21:
				spi_output =  (uint32_t)(P_reactive>>8)<<16 | (uint16_t)P_active>>8 ;
				break;
				
				case 0x22:
				spi_output = ((uint32_t)pos_pf<<28)			|		((uint32_t)pos_angle<<27)		|		((uint32_t)power_factor & 0x7FF)<<16	 |  (uint16_t) P_apparent>>8 ;
				break;

				case 0x25:
				spi_output = N; // numptsout
				break;
				
				case 0x26:
				spi_output = N; // numptsout
				break;


				case 0x2A:
				spi_output = (int32_t) i_inst<<16 | (uint16_t)v_inst;
				break;
				
			}
			flag_8bit = 0;
			//spi_output = 0x23456789;
			//SPI0.DATA = 0;
			//while(!(SPI0.INTFLAGS & SPI_DREIE_bm));
			//spi_output = spi_output;
			SPI0.DATA = spi_output;
			spi_output = spi_output>>8;
			reg_addr = SPI0.DATA;
			temp = SPI0.DATA;
			
			break;
		}
	/*
	 * Insert your SPI interrupt handling code here
	 *
	 * All SPI interrupts share the same interrupt line. Need to
	 * check INTFLAGS register to see which one is triggered.
	 */
}
