#include <atmel_start.h>
volatile	uint32_t  result=0x11223344;
#include <math.h>
//#include <util/delay.h>
//#include <stdio.h>
//extern int32_t  Pactive_i;
volatile uint32_t P_active_t, Irms_t, Vrms_t,Irms_t_sampled, Vrms_t_sampled;

volatile int16_t i_inst, v_inst=0, old_v_inst, power_factor=0;

volatile uint32_t P_active=0, P_active_t_sampled, Irms=0xab, Vrms=0xcd, P_apparent=0, P_reactive=0;
float Irms_float, Vrms_float;

volatile float Vrms_avg_1st=0, Irms_avg_1st=0, P_active_avg_1st=0;
volatile float Vrms_avg_2nd=0, Irms_avg_2nd=0, P_active_avg_2nd=0;
uint8_t avg_counter_1st=0, avg_counter_2nd=0;

volatile uint16_t N = 0;

volatile extern uint8_t cycle_finished ;
volatile int16_t sample_counter;
volatile uint16_t cycle_counter=0;
bool pos_angle, pos_pf;


const uint8_t avg_1st_limit = 100;
const uint16_t avg_2nd_limit = 1000;

int main(void)
{

	/* Initializes MCU, drivers and middleware */
	atmel_start_init();
	//SPI0.INTFLAGS = 0xff;
	/* Replace with your application code */
	ADC0.COMMAND |= ADC_START_IMMEDIATE_gc;
	while (1) {

		//VPORTB.OUT |= (1 << 7); // PB7 ON
		//VPORTB.OUT &= ~(1 << 7); // PB7 OFF
		
		while(cycle_finished!= 1){;}

		// Sampling all 
		N = sample_counter;
		sample_counter=0; P_active_t_sampled=P_active_t, Irms_t_sampled=Irms_t, Vrms_t_sampled=Vrms_t;
		P_active_t=0; Irms_t=0; Vrms_t=0; cycle_finished =0;
		
		//restart ADC after storing values
		ADC0.COMMAND |= ADC_START_IMMEDIATE_gc;

		
		/****	Post-Cycle Calculations	***/

		// RMS values
		Irms_float = sqrt((float)Irms_t_sampled / (float)N);
		Vrms_float = sqrt((float)Vrms_t_sampled / (float)N);
		Irms = Irms_float;
		Vrms = Vrms_float;

		// Apparent power
		P_apparent = abs(Vrms_float * Irms_float);
		
		// Active and reactive powers
		P_active = P_active_t_sampled / N;
		P_reactive = sqrt(pow(P_apparent,2) - pow(P_active,2));
		
		//Power factor
		power_factor =  (P_active*1023) /  P_apparent;
		
		// Sign of PF and Reactive Power
		if(P_reactive <0)
			pos_angle =0;
		else
			pos_angle = 1;
			
		if(power_factor < 0)
			pos_pf =0;
		else
			pos_pf =1;
						
		avg_counter_1st++;
		
		
		
		
		/************ Averaging ******************/
				
		//Irms_avg_1st -= Irms_avg_1st / avg_1st_limit
		//Irms_avg_1st += (float)Irms / avg_1st_limit;
		//Vrms_avg_1st -= Vrms_avg_1st / avg_1st_limit
		//Vrms_avg_1st +=(float)Vrms / avg_1st_limit;
		
		//if(avg_counter_1st >= avg_1st_limit)
		//{
			//
			//avg_counter_1st =0;
			//avg_counter_2nd ++;
		//}	
		
		
	}
}
